{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit DDOTestTypes;

{$I DDObjectsTests.inc}

interface

type
  TTestEnum = (teValue1, teValue2, teValue3, teValue4);
  TTestEnums = set of TTestEnum;

  TTestRecord = record
    AnInteger: Integer;
    ABoolean: Boolean;
    AString: String;
  end;

  TTestArray = array of String;

  TTestRecordEx = record
    AVariant: Variant;
    ADynArray: TTestArray;
    AArray: array[0..4] of Byte;
    ASet: TTestEnums;
  end;

  function GetDefaultRecord: TTestRecord;
  procedure CompareRecord(ARecordA, ARecordB: TTestRecord); overload;
  function EditRecord(ARecord: TTestRecord): TTestRecord;
  function GetDefaultRecordEx: TTestRecordEx;
  procedure CompareRecord(ARecordA, ARecordB: TTestRecordEx); overload;

implementation

uses
  SysUtils;

//----------------------------------------------------------------------------
//2006-12-28 00:27 N,SM:

procedure CompareRecord(ARecordA, ARecordB: TTestRecordEx);
  procedure nCompare(ARecord: TTestRecordEx);
  var
    i: Integer;
  begin
    Assert(Length(ARecord.ADynArray) = 5);
    Assert(Length(ARecord.ADynArray) = 5);
    for i := 0 to 4 do
    begin
      Assert(ARecord.ADynArray[i] = IntToStr(i));
      Assert(ARecord.AArray[i] = i);
    end;
  end;
begin
  nCompare(ARecordA);
  nCompare(ARecordB);
end;

//----------------------------------------------------------------------------
//2006-12-28 00:23 N,SM:

function GetDefaultRecordEx: TTestRecordEx;
var
  i: Integer;
begin
  Result.AVariant := 'test';
  SetLength(Result.ADynArray, 5);
  for i := 0 to 4 do
  begin
    Result.ADynArray[i] := IntToStr(i);
    Result.AArray[i] := i;
  end;
  Result.ASet := [teValue2, teValue3];
end;

//----------------------------------------------------------------------------
//2006-12-27 13:46 N,SM:

function GetDefaultRecord: TTestRecord;
begin
  Result.AnInteger := 42;
  Result.ABoolean := True;
  Result.AString := 'test';
end;

//----------------------------------------------------------------------------
//2006-12-27 13:46 N,SM:

procedure CompareRecord(ARecordA, ARecordB: TTestRecord);
begin
  Assert(ARecordA.AnInteger = ARecordB.AnInteger);
  Assert(ARecordA.ABoolean = ARecordB.ABoolean);
  Assert(ARecordA.AString = ARecordB.AString);
end;

//----------------------------------------------------------------------------
//2006-12-27 15:44 N,SM:

function EditRecord(ARecord: TTestRecord): TTestRecord;
begin
  Result.AnInteger := ARecord.AnInteger * 2;
  Result.ABoolean := not ARecord.ABoolean;
  Result.AString := ARecord.AString + ARecord.AString;
end;

end.
