 // ************************************************************
 //  This unit has been created using DDOWizard 0.9.96
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 25.01.2007 23:25:27
 // ************************************************************

unit uDDOPersistentTests_Proxy;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TDDOPersistentTests = class(TDDOProxyBase)
  private
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
    procedure SetStrings(AStrings: TObject);
    procedure SetList(Value: TObject);
    procedure GetStrings(out DDOParam0: TObject);
    procedure GetList(out DDOParam0: TObject);
    procedure NilOut(out Value: TObject);
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TDDOPersistentTests.GetVersion: String;
begin
  Result := '{5B7B645F-2712-46EF-82C3-BC47630F3A67}';
end;

function TDDOPersistentTests.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TDDOPersistentTests.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TDDOPersistentTests.SetStrings(AStrings: TObject);
begin
  PrepareCall('SetStrings');
  SetIDDOPersistent('AStrings', AStrings);
  SendRequest;
end;

procedure TDDOPersistentTests.SetList(Value: TObject);
begin
  PrepareCall('SetList');
  SetIDDOPersistent('Value', Value);
  SendRequest;
end;

procedure TDDOPersistentTests.GetStrings(out DDOParam0: TObject);
begin
  PrepareCall('GetStrings');
  SendRequest;
  DDOParam0 := GetIDDOPersistent('DDOParam0');
end;

procedure TDDOPersistentTests.GetList(out DDOParam0: TObject);
begin
  PrepareCall('GetList');
  SendRequest;
  DDOParam0 := GetIDDOPersistent('DDOParam0');
end;

procedure TDDOPersistentTests.NilOut(out Value: TObject);
begin
  PrepareCall('NilOut');
  SendRequest;
  Value := GetIDDOPersistent('Value');
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
