 // ************************************************************
 //  This unit has been created using DDOWizard 0.9.90
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 08.01.2007 08:07:54
 // ************************************************************

unit uAsyncDemo_Proxy;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TGetSomeDataEvent = procedure (Sender: TDDOProxyBase; GUID: String; Data: String) of object;

type
  TAsyncDemo = class(TDDOProxyBase)
  private
    procedure _GetSomeData(GUID: String; Callback: TMethod);
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
    function GetSomeData(ID: Integer; Callback: TGetSomeDataEvent): String;
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TAsyncDemo.GetVersion: String;
begin
  Result := '{21251581-6BD0-43B9-B707-5FDAAF8D2EE1}';
end;

function TAsyncDemo.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TAsyncDemo.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
    0: _GetSomeData(GUID, Method);
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TAsyncDemo._GetSomeData(GUID: String; Callback: TMethod);
var
  Data: String;
begin
  Data := GetParam('Data', False);
  TGetSomeDataEvent(Callback)(Originator, GUID, Data);
end;

function TAsyncDemo.GetSomeData(ID: Integer; Callback: TGetSomeDataEvent): String;
begin
  PrepareCall('GetSomeData');
  SetParam('ID', ID, False);
  Result := AddEvent(SendAsyncRequest, TMethod(Callback), 0);
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
