 // ************************************************************
 //  This unit has been created using DDOWizard 0.9.90
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 08.01.2007 08:07:54
 // ************************************************************

unit uClientCallback_ProxyDelegate;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TNotificationEvent = procedure (Sender: TDDOProxyBase; GUID: String) of object;

type
  TClientCallbackDelegate = class(TDDOProxyDelegateBase)
  private
    procedure _Notification(GUID: String; Callback: TMethod);
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TClientCallbackDelegate.GetVersion: String;
begin
  Result := '{75C04E5B-E439-43A2-891B-A59B2AABAFA0}';
end;

function TClientCallbackDelegate.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TClientCallbackDelegate.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
    0: _Notification(GUID, Method);
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TClientCallbackDelegate._Notification(GUID: String; Callback: TMethod);
begin
  TNotificationEvent(Callback)(Originator, GUID);
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
