{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uServerMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Spin, DDOServer, DDODocument, ComCtrls,
  ExtCtrls, uServerBaseForm, DDOUtils, DDOBase, DDODataGrid, DDOProgressBar;

type
  TServerMainForm = class(TServerBaseForm)
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    FQuotes: TStringList;
    procedure SendQuote(Stub: TDDOStubBase; UserData: Integer;
      var Continue: Boolean);
  protected
    procedure UpdateGUI; override;  
  end;

var
  ServerMainForm: TServerMainForm;

implementation

uses
  DDOClient, uClientCallback_Stub;

{$R *.dfm}

type
  TClientCallback = class(TClientCallback_ActiveStub)
  public
    procedure SubscriptionChanged; override;
  end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.FormCreate(Sender: TObject);
begin
  FQuotes := TStringList.Create;
  FQuotes.LoadFromFile('Quotes.txt');
  DDOListener1.RegisterClass(TClientCallback);
  inherited;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.SendQuote(Stub: TDDOStubBase;
  UserData: Integer; var Continue: Boolean);
begin
  Assert(Stub is TClientCallback);
  TClientCallback(Stub).Notification(Now,
    FQuotes[Random(FQuotes.Count)], nil);
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  try
    DDOListener1.EnumStubs(TClientCallback, SendQuote, 0);
  finally
    Timer1.Enabled := True;
  end;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.FormDestroy(Sender: TObject);
begin
  inherited;
  FreeAndNil(FQuotes);
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.TrackBar1Change(Sender: TObject);
begin
  inherited;
  UpdateGUI;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.UpdateGUI;
begin
  inherited;
  Timer1.Interval := TrackBar1.Position * 250;
end;

//----------------------------------------------------------------------------
//2007-01-08 08:12 N,SM:

procedure TClientCallback.SubscriptionChanged;
begin
  inherited;
  ServerMainForm.Timer1.Enabled := ProxyCount > 0;
end;

end.
