{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit DemoClientMainForm;

interface

uses
  Windows, Messages, SysUtils, DDOBase, DDOClient, Classes, Controls,
  StdCtrls, Forms, Dialogs,  
  uTestClassA_Proxy, uTestClassB_Proxy;

type
  TForm1 = class(TForm)
    DDORequester1: TDDORequester;
    BtnLookupA: TButton;
    BtnLookupB: TButton;
    BtnCallA: TButton;
    BtnCallB: TButton;
    procedure BtnLookupAClick(Sender: TObject);
    procedure BtnLookupBClick(Sender: TObject);
    procedure BtnCallAClick(Sender: TObject);
    procedure BtnCallBClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FProxyA: TTestClassA;
    FProxyB: TTestClassB;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TForm1.BtnLookupAClick(Sender: TObject);
begin
  BtnCallA.Enabled := False;
  FreeAndNil(FProxyA);
  FProxyA := DDORequester1.Lookup(TTestClassA) as TTestClassA;
  BtnCallA.Enabled := True;
end;

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TForm1.BtnLookupBClick(Sender: TObject);
begin
  BtnCallB.Enabled := False;
  FreeAndNil(FProxyB);
  FProxyB := DDORequester1.Lookup(TTestClassB) as TTestClassB;
  BtnCallB.Enabled := True;
end;

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TForm1.BtnCallAClick(Sender: TObject);
var
  lSomeInfo: String;
begin
  FProxyA.GetInfo(lSomeInfo);
  MessageDlg(lSomeInfo, mtInformation, [mbOK], 0);
end;

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TForm1.BtnCallBClick(Sender: TObject);
var
  lSomeInfo: String;
begin
  FProxyB.GetInfo(lSomeInfo);
  MessageDlg(lSomeInfo, mtInformation, [mbOK], 0);
end;

//----------------------------------------------------------------------------
//2006-02-27 N,SM:

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FProxyA);
  FreeAndNil(FProxyB);  
end;

end.
