{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uDemoMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActnList, ComCtrls, ToolWin, ExtCtrls, uDemoClient,
  DDOBase, DDOClient, ImgList, uPersistentDemo_Proxy, Spin;

type
  TClientMainForm = class(TForm)
    Panel2: TPanel;
    ToolBar1: TToolBar;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActionList1: TActionList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LabelID: TLabel;
    Label9: TLabel;
    EditName: TEdit;
    EditEMail: TEdit;
    EditURL: TEdit;
    MemoInfo: TMemo;
    ImageList1: TImageList;
    ActionLoad: TAction;
    ActionStore: TAction;
    ActionUndo: TAction;
    ActionExit: TAction;
    DDORequester1: TDDORequester;
    EditPort: TSpinEdit;
    EditHost: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ActionLoadExecute(Sender: TObject);
    procedure ActionStoreExecute(Sender: TObject);
    procedure ActionUndoExecute(Sender: TObject);
    procedure ActionExitExecute(Sender: TObject);
  private
    FProxy: TPersistentDemo;
    FClient: TDemoClient;
    procedure SetClient(Value: TDemoClient);
  private
    procedure Data2GUI;
    procedure GUI2Data;
  protected
    procedure UpdateGUI;
    procedure LoadClient(ID: Integer);
    property Client: TDemoClient read FClient write SetClient;
  end;

var
  ClientMainForm: TClientMainForm;

implementation

uses
  DDOUtils;

{$R *.dfm}

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.UpdateGUI;
begin
  Data2GUI;
  EditHost.Text := DDORequester1.Host;
  EditPort.Value := DDORequester1.Port;
  EditHost.Enabled := not DDORequester1.Active;
  EditPort.Enabled := not DDORequester1.Active;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.FormCreate(Sender: TObject);
begin
  Client := TDemoClient.Create(0);
  FProxy := TPersistentDemo.Create(DDORequester1);
  UpdateGUI;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.FormDestroy(Sender: TObject);
begin
  Client := nil;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.ActionLoadExecute(Sender: TObject);
begin
  LoadClient(0);
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.ActionStoreExecute(Sender: TObject);
begin
  GUI2Data;
  FProxy.SetClient(Client);
  UpdateGUI;  
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.ActionUndoExecute(Sender: TObject);
begin
  LoadClient(Client.ID);
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.LoadClient(ID: Integer);
var
  lClient: TObject;
begin
  FProxy.GetClient(ID, lClient);
  Client := lClient as TDemoClient;
  UpdateGUI;
end;

//----------------------------------------------------------------------------
//2006-02-20 N,SM:

procedure TClientMainForm.SetClient(Value: TDemoClient);
begin
  FreeAndNil(FClient);
  FClient := Value;
end;

//----------------------------------------------------------------------------
//2006-02-22 N,SM:

procedure TClientMainForm.Data2GUI;
begin
  with Client do
  begin
    LabelID.Caption := IntToStr(ID);
    EditName.Text := Name;
    EditEMail.Text := EMail;
    EditURL.Text := URL;
    MemoInfo.Lines := Info;
  end;
end;

//----------------------------------------------------------------------------
//2006-02-22 N,SM:

procedure TClientMainForm.GUI2Data;
begin
  with Client do
  begin
    Name := EditName.Text;
    EMail := EditEMail.Text;
    URL := EditURL.Text;
    Info := MemoInfo.Lines;
  end;
end;

end.
