{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uClientMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, DDOClient, DDOBase,
  uDDOSessionLogIn_Proxy, uDDOSessionTest_Proxy;

type
  TClientMainForm = class(TForm)
    EditPort: TSpinEdit;
    Label1: TLabel;
    EditHost: TEdit;
    Label2: TLabel;
    ButtonLogIn: TButton;
    MemoResult: TMemo;
    DDORequester1: TDDORequester;
    ButtonLogOff: TButton;
    ButtonGetData: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditHostChange(Sender: TObject);
    procedure EditPortChange(Sender: TObject);
    procedure ButtonLogInClick(Sender: TObject);
    procedure ButtonLogOffClick(Sender: TObject);
    procedure ButtonGetDataClick(Sender: TObject);
  private
    FDemoClass: TDDOSessionTest;
    FLogInClass: TDDOSessionLogIn;
  end;

var
  ClientMainForm: TClientMainForm;

implementation

{$R *.dfm}

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.FormCreate(Sender: TObject);
begin
  EditHost.Text := DDORequester1.Host;
  EditPort.Value := DDORequester1.Port;
  FDemoClass := TDDOSessionTest.Create(DDORequester1);
  FLogInClass := TDDOSessionLogIn.Create(DDORequester1);
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FDemoClass);
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.EditHostChange(Sender: TObject);
begin
  DDORequester1.Host := EditHost.Text;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.EditPortChange(Sender: TObject);
begin
  DDORequester1.Port := EditPort.Value;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.ButtonLogInClick(Sender: TObject);
begin
  FLogInClass.LogIn('test', 'test');
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.ButtonLogOffClick(Sender: TObject);
begin
  FLogInClass.LogOff;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TClientMainForm.ButtonGetDataClick(Sender: TObject);
var
  AText: String;
begin
  FDemoClass.GetData(AText);
  MemoResult.Text := AText;
end;

end.
