 // ************************************************************
 //  This unit has been created using DDOWizard 1.0
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 05.03.2007 23:07:31
 // ************************************************************

unit uDemoClassCallbackListener_Proxy;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOClient;

type
  TNotificationEvent = procedure (Sender: TDDOProxyBase; GUID: String) of object;

type
  TDemoClassCallbackListener = class(TDDOProxyBase)
  private
    procedure _Notification(GUID: String; Callback: TMethod);
  protected
    function IsCachedRequest(const MethodName: string): Boolean; override;
    procedure DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer); override;
  public
    function Notification(Time: TDateTime; Data: String; Callback: TNotificationEvent): String;
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TDemoClassCallbackListener.GetVersion: String;
begin
  Result := '{C04F9224-C32A-4F2B-85C6-831D4FD3D590}';
end;

function TDemoClassCallbackListener.IsCachedRequest(const MethodName: string): Boolean;
begin
  Result := False
end;

procedure TDemoClassCallbackListener.DispatchCall(const GUID: String; Method: TMethod; ADispID: Integer);
begin
  inherited;
  case ADispID of
    -1: ; // dummy;
    0: _Notification(GUID, Method);
  else
    raise EDDOError.CreateResFmt(@SImplementationNotFound, [ADispID]);
  end;
end;

procedure TDemoClassCallbackListener._Notification(GUID: String; Callback: TMethod);
begin
  TNotificationEvent(Callback)(Originator, GUID);
end;

function TDemoClassCallbackListener.Notification(Time: TDateTime; Data: String; Callback: TNotificationEvent): String;
begin
  PrepareCall('Notification');
  SetParam('Time', Time, True);
  SetParam('Data', Data, False);
  Result := AddEvent(SendAsyncRequest, TMethod(Callback), 0);
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
